<apex:page standardcontroller="Work_Order_Activity__c" extensions="VTT_ActivityDetailTimeLogControllerX" showHeader="true" sidebar="true" cache="true" title="Work Order Activity" docType="html-5.0">

    <apex:includescript value="https://ajax.googleapis.com/ajax/libs/jquery/1.11.0/jquery.min.js" />      
    <apex:includescript value="https://maps.googleapis.com/maps/api/js?v=3.exp&sensor=true" /> 

    <style>
        #j_id0\:j_id31\:editsection\:RunningTallyTime > div.pbSubheader.brandTertiaryBgr.tertiaryPalette
        {
            margin-bottom:18px!important;
        }

        .custom_btn 
        {
            text-decoration: none!important;
            font-weight: bold!important;
            font-size: 1em!important;
            margin-left: 10px!important;
            padding: 2px 4px!important;
        }
        .runningTallyText{
            font-weight: bold!important;
            font-size: 1.1em;
            float: left;
            padding: 2px;
            margin-top: -3px!important;
            color: black;
        }
        .runningTallyTime{
            font-weight: bold!important;
            font-size: 1.1em;
            /*background-color: rgba(229, 193, 48, 0.6);*/
            color:red!important;
            float: left;
            padding: 2px 5px;
            margin-top: -3px!important;
            color: black;
        }
        .hint{
            color:#696969!important;
        }
        td.data2Col.first.last
        {
            width:50%!important;
        }
        .label
        {
            padding-right:20px;
            text-align:right;
            font-size: 91%;
            font-weight:bold;
            width:10%;
        }

        .dataCol2
        {
            text-align:left;
            width:10%;
        }
        #j_id0\:j_id31\:editsection\:CompleteMultiple\:j_id319\:RunningTallyheader{background-color:rgba(229, 193, 48, 0.6);}
    </style>    

    <script>
        j$ = jQuery.noConflict();

        j$( document ).ready(function() {
          getCurrentLocation();
        });

        function setFocusOnComplete() {} //Set focus on comment fields on actioncomplete (Surprisingly)

        function getCurrentLocation()
        {
            if(!!navigator.geolocation) {   
                navigator.geolocation.getCurrentPosition(function(position) {
                    var geolocate = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
                    j$('input[id$=inputLatitude]').val(position.coords.latitude);
                    j$('input[id$=inputLongitude]').val(position.coords.longitude);
                });
            }
        } 

        
        function doSfOneNavigation(id, page, idName, executeFunction){
            var url;
            if(idName && id){
                if( typeof sforce != "undefined" && sforce && sforce.one ) {
                    url = page + '&'+idName+'=' + id;  
                } else {
                    url = page + '?'+idName+'=' + id; 
                }
            } else {
                url= page;
            }
            
            console.log('URL ' + url);
            
            if(executeFunction == true){
                if( typeof sforce != "undefined" && sforce && sforce.one ) {
                    executeWSUpdateNotification();
                    sforce.one.navigateToURL(url); 
                } else {
                    window.location = url;
                }
                
            } else {
                if( typeof sforce != "undefined" && sforce && sforce.one ) {
                    sforce.one.navigateToURL(url); 
                } else {
                    window.location = url;
                }
            }
        }
    </script>    

    <apex:actionstatus id="ajaxStatus">
        <apex:facet name="start">
            <div class="waitingSearchDiv" id="el_loading" style="background-color: rgb(54, 25, 25); background-color: rgba(25, 25, 25, .5); height: 100%;width:100%;">
                <div class="waitingHolder" style="top: 200px; width: 500px; height: 40px; border:1px solid black;  background-color: white;">
                    <p>
                        <img class="waitingImage" src="/img/loading.gif" title="Please Wait..." />
                        <span class="waitingDescription">Do not navigate away from the page Salesforce is communicating with SAP ...</span>
                    </p>
                </div>
            </div>
        </apex:facet> 
    </apex:actionstatus>


    <apex:sectionHeader title="Activity Tracking" subtitle="{!workflowEngine.ViewScreenDescription}"/>
    <apex:pageMessages id="errors" escape="false" />

    <apex:form >

        <apex:outputPanel rendered="{!workflowEngine.PageReloadRequired}">
            <apex:pageBlock mode="maindetail">
            <apex:pageMessage title="This Activity was recently modified. Please reload this page." severity="warning" strength="3"/>
             <apex:pageBlockButtons location="bottom">
                <apex:commandButton action="{!workflowEngine.ReloadCurrentPage}" value="Reload Page"/>         
              </apex:pageBlockButtons>
            </apex:pageBlock>
        </apex:outputPanel>




            <!-- Hidden fields for coordinates -->

            <apex:inputHidden value="{!workflowEngine.CurrentLatitude}" id="inputLatitude"/>
            <apex:inputHidden value="{!workflowEngine.CurrentLongitude}" id="inputLongitude"/>


            <!-- and bunch of fields we want to have access to in the controller but we don't want to display on the screen -->

            <apex:outputPanel rendered="false">

                <apex:outputfield value="{!Work_Order_Activity__c.Maintenance_Work_Order__r.Notification_Number__c}"/>

                <apex:outputfield value="{!Work_Order_Activity__c.Maintenance_Work_Order__r.Location__c}" />
                <apex:outputField value="{!Work_Order_Activity__c.Maintenance_Work_Order__r.Facility__c}" />

                <apex:outputfield value="{!Work_Order_Activity__c.Maintenance_Work_Order__r.Equipment__r.Catalogue_Code__c}"/>
                <apex:outputfield value="{!Work_Order_Activity__c.Maintenance_Work_Order__r.On_Hold__c}"/>

                
                <apex:outputfield value="{!Work_Order_Activity__c.Part__c}" />
                <apex:outputfield value="{!Work_Order_Activity__c.Part__r.Part_Code__c}" />
                <apex:outputfield value="{!Work_Order_Activity__c.Part__r.Part_Description__c}" />                
                <apex:outputfield value="{!Work_Order_Activity__c.Damage__c }" />
                <apex:outputfield value="{!Work_Order_Activity__c.Cause__c }" />
                <apex:outputfield value="{!Work_Order_Activity__c.Cause__r.Cause_Code__c}" /> 
                <apex:outputfield value="{!Work_Order_Activity__c.Location__c}" />
                <apex:outputField value="{!Work_Order_Activity__c.Facility__c}" />               
                <apex:inputHidden value="{!Work_Order_Activity__c.Part__r}" />

                <apex:outputfield value="{!Work_Order_Activity__c.LastModifiedById}"/>                
                <apex:outputfield value="{!Work_Order_Activity__c.LastModifiedDate}"/>  
              
                <apex:dataTable value="{!Work_Order_Activity__c.Working_Tradesmen__r}" var="tradesmanRecord">
                    <apex:column value="{!tradesmanRecord.id}"/>
                    <apex:column value="{!tradesmanRecord.Name}"/>
                    <apex:column value="{!tradesmanRecord.Tradesman_Status__c}"/>
                    <apex:column value="{!tradesmanRecord.Tradesman_Status_Date__c}"/>
                    <apex:column value="{!tradesmanRecord.Account.Name}"/>
                    <apex:column value="{!tradesmanRecord.Phone}"/>                   
                </apex:dataTable>

                <apex:outputField value="{!Work_Order_Activity__c.Operating_Field_AMU__c}"/>
                <apex:outputField value="{!Work_Order_Activity__c.Operating_Field_AMU__r.Is_Thermal__c}"/>
            </apex:outputPanel>

            <apex:pageBlock id="viewsection" mode="maindetail" rendered="{!workflowEngine.ViewMode}">

                <apex:pageBlockButtons rendered="{!workflowEngine.ViewMode}" location="top">  

                    <apex:outputPanel rendered="{!AND(workflowEngine.userHasEditAccess,NOT(workflowEngine.PageReloadRequired))}">  
                        <apex:commandButton action="{!workflowEngine.RejectActivity_Start}" value="Reject Activity"
                        rendered="{!workflowEngine.CanRejectActivity}"/>

                        <apex:commandButton action="{!workflowEngine.GenericActivity_Start1}" value="{!workflowEngine.WorkFlowActions[0].ActionName}" rendered="{!and(workflowEngine.CanExecuteAction, workflowEngine.WorkFlowActions.size>0)}">
                            <apex:param name="nickName"
                                            value="{!workflowEngine.WorkFlowActions[0].ActionName}"
                                            assignTo="{!workflowEngine.ActionName}"/>

                        </apex:commandButton>

                        <apex:commandButton action="{!workflowEngine.GenericActivity_Start2}" value="{!workflowEngine.WorkFlowActions[1].ActionName}" rendered="{!and(workflowEngine.CanExecuteAction, workflowEngine.WorkFlowActions.size>1)}">
                            <apex:param name="nickName"
                                            value="{!workflowEngine.WorkFlowActions[1].ActionName}"
                                            assignTo="{!workflowEngine.ActionName}"/>                       
                        </apex:commandButton>

                        <apex:commandButton action="{!workflowEngine.StartJobAtEquipment_Start}" value="Start Job at Equipment"
                        rendered="{!workflowEngine.CanStartJobAtEquipment}" />

                        <apex:commandButton action="{!workflowEngine.ActivityOnHold_Start}" value="Job On Hold" 
                        rendered="{!workflowEngine.CanPutActivityOnHold}"/>
                        <apex:commandButton action="{!workflowEngine.JobComplete_Start}" value="Job Complete" 
                        rendered="{!workflowEngine.CanCompleteJob}" />                
                    </apex:outputPanel>   
                        
                    <apex:commandButton action="{!VTT_Assignment}" value="Manage Assignments" rendered="{!workflowEngine.CanManageAssignments && !isSalesforce1}"/>
                    <apex:commandButton reRender="viewsection" onclick="doSfOneNavigation('{!woId}', '{!URLFOR($Site.Prefix + '/apex/VTT_TradesmanAssignment')}', 'id', false)" value="Manage Assignments" rendered="{!workflowEngine.CanManageAssignments && isSalesforce1}"/>

                    <!-- Edit -->
                    <apex:commandButton action="{!EditActivity}" value="Edit" rendered="{!workflowEngine.IsAdmin && !isSalesforce1}"/>
                    <apex:commandButton reRender="viewsection" onclick="doSfOneNavigation('{!woId}', '{!URLFOR($Site.Prefix + '/' + woId + '/e?retURL=/' + woId)}', 'id', false)" value="Manage Assignments" rendered="{!workflowEngine.IsAdmin && isSalesforce1}"/>

                    <!-- Exit from the form and redirect to the list for standard vf page-->
                    <apex:commandButton rendered="{!!isSalesforce1}" action="{!VTT_Cancel}" value="Exit"/> 
                    <!-- Exit from the form and redirect to the list - sf1 navigation -->
                    <apex:commandButton id="sfOneButton" value="Exit" 
                    onclick="doSfOneNavigation(undefined, '{!URLFOR($Site.Prefix + '/apex/VTT_ActivityListView')}', undefined, false)"
                    rendered="{!isSalesforce1}" reRender="viewsection" /> 
                </apex:pageBlockButtons> 

                <apex:pageBlockSection title="Work Order Header Information" id="workOrderHeaderInformation" columns="1">

                    <apex:panelGrid columns="6" width="100%" 
                    columnClasses="label, dataCol2, label, dataCol2, label, dataCol2">


                                <apex:outputLabel value="Work Order" />
                                <apex:outputField value="{!Work_Order_Activity__c.Maintenance_Work_Order__c}"/>

                                <apex:outputLabel value="{!$ObjectType.HOG_Maintenance_Servicing_Form__c.fields.Order_Description__c.Label}" />
                                <apex:outputField value="{!Work_Order_Activity__c.Maintenance_Work_Order__r.Order_Description__c}"/>

                                <apex:outputLabel value="{!$ObjectType.HOG_Maintenance_Servicing_Form__c.fields.Operating_Field_AMU_Lookup__c.Label}" />
                                <apex:outputField value="{!Work_Order_Activity__c.Maintenance_Work_Order__r.Operating_Field_AMU_Lookup__c}"/>
                                                
                                <apex:outputLabel value="{!$ObjectType.HOG_Maintenance_Servicing_Form__c.fields.Location__c.Label}" />
                                <apex:outputLink value="/{!Work_Order_Activity__c.Maintenance_Work_Order__r.Location__c}"> {!Work_Order_Activity__c.Maintenance_Work_Order__r.Location__r.Name}</apex:outputLink>

                                <apex:outputLabel value="Functional Location" />
                                <apex:outputLink rendered="{!renderOrderFlocLink}" value="/{!orderFlocId}">{!nameOfOrderFloc}</apex:outputLink>
                                <apex:outputField rendered="{!!renderOrderFlocLink}" value="{!Work_Order_Activity__c.Maintenance_Work_Order__r.Functional_Location__c}"/>


                                <apex:outputLabel value="{!$ObjectType.HOG_Maintenance_Servicing_Form__c.fields.Requested_Start_Time__c.Label}" />
                                <apex:outputField value="{!Work_Order_Activity__c.Maintenance_Work_Order__r.Requested_Start_Time__c}"/>

                                <apex:outputLabel value="{!$ObjectType.HOG_Maintenance_Servicing_Form__c.fields.Operator_Route__c.Label}" />
                                <apex:outputField value="{!Work_Order_Activity__c.Maintenance_Work_Order__r.Operator_Route__c}"/> 
                                                               
                                <apex:outputLabel value="{!$ObjectType.HOG_Maintenance_Servicing_Form__c.fields.Equipment__c.Label}" />
                                <apex:outputLink value="/{!Work_Order_Activity__c.Maintenance_Work_Order__r.Equipment__c}"> {!Work_Order_Activity__c.Maintenance_Work_Order__r.Equipment__r.Description_of_Equipment__c}</apex:outputLink>
                                
                                <apex:outputLabel value="{!$ObjectType.HOG_Maintenance_Servicing_Form__c.fields.Requested_Stop_Time__c.Label}" />
                                <apex:outputField value="{!Work_Order_Activity__c.Maintenance_Work_Order__r.Requested_Stop_Time__c}"/>  

                                <apex:outputLabel value="{!$ObjectType.HOG_Maintenance_Servicing_Form__c.fields.Main_Work_Centre__c.Label}" />
                                <apex:outputField value="{!Work_Order_Activity__c.Maintenance_Work_Order__r.Main_Work_Centre__c}"/>                                

                                <apex:outputLabel value="{!$ObjectType.HOG_Maintenance_Servicing_Form__c.fields.Required_End_Date__c.Label}" />
                                <apex:outputField value="{!Work_Order_Activity__c.Maintenance_Work_Order__r.Required_End_Date__c}"/>

                                <apex:outputLabel value="{!$ObjectType.HOG_Maintenance_Servicing_Form__c.fields.Facility__c.Label}" />
                                <apex:outputField value="{!Work_Order_Activity__c.Maintenance_Work_Order__r.Facility__r.Name}"/>

                                <apex:outputLabel value="{!$ObjectType.HOG_Maintenance_Servicing_Form__c.fields.Service_Status__c.Label}" />
                                <apex:outputField value="{!Work_Order_Activity__c.Maintenance_Work_Order__r.Service_Status__c}"/> 
                                
                                <apex:outputLabel value="{!$ObjectType.HOG_Maintenance_Servicing_Form__c.fields.Work_Order_Priority_Number__c.Label}" />
                                <apex:outputField value="{!Work_Order_Activity__c.Maintenance_Work_Order__r.Work_Order_Priority_Number__c}"/>                                                               
                    </apex:panelGrid>
                </apex:pageBlockSection>


                <apex:pageBlockSection title="Work Order Activity Detail" collapsible="false" columns="1">
                    <apex:panelGrid columns="6" width="100%" 
                    columnClasses="label, dataCol2, label, dataCol2, label, dataCol2">
<!-- ROW -->
                        <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.fields.Name.Label}" />
                        <apex:outputField value="{!Work_Order_Activity__c.Name}"/>

                        <apex:outputLabel value="Functional Location" />
                        <apex:outputLink rendered="{!renderActivityFlocLink}" value="/{!activityFlocId}">{!nameOfActivityFloc}</apex:outputLink>
                        <apex:outputField rendered="{!!renderActivityFlocLink}" value="{!Work_Order_Activity__c.Functional_Location__c}"/>

                        <apex:outputLabel />
                        <apex:outputLabel />

<!-- ROW -->
                        <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.fields.Assigned_Vendor__c.Label}" />
                        <apex:outputField value="{!Work_Order_Activity__c.Assigned_Vendor__c}"/>

                        <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.fields.Work_Center__c.Label}" />
                        <apex:outputField value="{!Work_Order_Activity__c.Work_Center__c}"/>

                        <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.fields.Number_of_people__c.Label}" />
                        <apex:outputField value="{!Work_Order_Activity__c.Number_of_people__c}"/>

<!-- ROW -->
                        <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.fields.Duration__c.Label}" />
                        <apex:panelGroup >
                            <apex:outputField value="{!Work_Order_Activity__c.Duration__c}"/>
                            &nbsp;
                            <apex:outputField value="{!Work_Order_Activity__c.Duration_units__c}"/>
                        </apex:panelGroup>

                        <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.fields.Work__c.Label}" />
                        <apex:panelGroup >
                            <apex:outputField value="{!Work_Order_Activity__c.Work__c}"/>
                            &nbsp;
                            <apex:outputField value="{!Work_Order_Activity__c.Work_units__c}"/>
                        </apex:panelGroup>                        

                        <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.fields.Scheduled_Start_Date__c.Label}" />
                        <apex:outputField value="{!Work_Order_Activity__c.Scheduled_Start_Date__c}"/>
<!-- ROW -->
                        <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.fields.Equipment__c.Label}" />
                        <apex:outputLink value="/{!Work_Order_Activity__c.Equipment__c}">{!Work_Order_Activity__c.Equipment__r.Description_of_Equipment__c}</apex:outputLink>

                        <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.fields.Location__c.Label}" />
                        <apex:outputField value="{!Work_Order_Activity__c.Location__c}"/>

                        <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.fields.Scheduled_Finish_Date__c.Label}" />
                        <apex:outputField value="{!Work_Order_Activity__c.Scheduled_Finish_Date__c}"/>
<!-- ROW -->

                        <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.fields.System_Status__c.Label}" />
                        <apex:outputField value="{!Work_Order_Activity__c.System_Status__c}"/>

                        <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.fields.System_Condition__c.Label}" />
                        <apex:outputField value="{!Work_Order_Activity__c.System_Condition__c}"/>

                        <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.fields.Gas_Permit__c.Label}" />
                        <apex:outputField value="{!Work_Order_Activity__c.Gas_Permit__c}"/>

<!-- ROW -->
                        <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.fields.Recipient__c.Label}" />
                        <apex:outputField value="{!Work_Order_Activity__c.Recipient__c}"/>

                        <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.fields.Unloading_Point__c.Label}" />
                        <apex:outputField value="{!Work_Order_Activity__c.Unloading_Point__c}"/>
                        
                        <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.fields.Electrical_Permit__c.Label}" />
                        <apex:outputField value="{!Work_Order_Activity__c.Electrical_Permit__c}"/>
                        
<!-- ROW -->                        
                        <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.fields.User_Status__c.Label}" />
                        <apex:outputField value="{!Work_Order_Activity__c.User_Status__c}"/>
                        

                    </apex:panelGrid>                 
                </apex:pageBlockSection>

                <apex:pageBlockSection title="Operator On Call" collapsible="false" columns="3">
                    <apex:panelGrid columns="2" width="100%" 
                    columnClasses="label, dataCol2" rendered="{!OperatorOnCall != null}">
                        <apex:outputLabel value="{!$ObjectType.Route__c.fields.Operator_on_Call_URL__c.Label}"/>
                        <apex:outputField value="{!OperatorOnCall.Name}"/>
                        <!-- ROW -->
                        <apex:outputLabel value="{!$ObjectType.Route__c.fields.Operator_on_Call_URL__c.Label} Tel"/>
                        <!--<apex:outputText value="{!IF(OperatorOnCall.MobilePhone == null, OperatorOnCall.Phone, OperatorOnCall.MobilePhone)}"/>-->
                        <a href="tel:{!IF(OperatorOnCall.MobilePhone == null, OperatorOnCall.Phone, OperatorOnCall.MobilePhone)}">{!IF(OperatorOnCall.MobilePhone == null, OperatorOnCall.Phone, OperatorOnCall.MobilePhone)}</a>
                    </apex:panelGrid>
                    <apex:pageMessage title="No Operator On Call Found" summary="Operator on Call not specified on Work Order or Work Order Activity" severity="warning" strength="1" rendered="{!OperatorOnCall == null}"/>
                </apex:pageBlockSection>

                <apex:pageBlockSection title="Parts & Damages" columns="2" collapsible="false">
                    <apex:outputField value="{!Work_Order_Activity__c.Part__c}" />
                    <apex:outputText /> 
                    <!-- rendered="{!showPartsDamageCause}" -->
                    <apex:outputField value="{!Work_Order_Activity__c.Damage__c}" />
                    <!-- rendered="{!showPartsDamageCause}" -->                    
                    <apex:outputField value="{!Work_Order_Activity__c.Cause__c}"/>
                    <!-- rendered="{!showPartsDamageCause}" -->                    
  
                    <apex:outputField value="{!Work_Order_Activity__c.Damage_Text__c}"/>
                    <!-- rendered="{!showPartsDamageCause}" -->                    
                    <apex:outputField value="{!Work_Order_Activity__c.Cause_Text__c}"/>
                    <!-- rendered="{!showPartsDamageCause}" -->                    

                    <apex:outputField value="{!Work_Order_Activity__c.Work_Details__c}" />
                    <apex:outputField value="{!Work_Order_Activity__c.Part_Key__c}" /> 
                    <!-- <apex:outputField value="{!Work_Order_Activity__c.Maintenance_Work_Order__r.Tag_Number__c}"/> -->
                </apex:pageBlockSection>



                <apex:pageBlockSection title="Time & Status" columns="2" collapsible="false">

                    <apex:outputField value="{!Work_Order_Activity__c.Status__c}" />
                    <apex:outputField value="{!Work_Order_Activity__c.Time_Spent_Off_Equipment_Text__c}" />

                    <apex:outputField value="{!Work_Order_Activity__c.Status_Reason__c}" />
                    <apex:outputField value="{!Work_Order_Activity__c.Time_Spent_On_Equipment_Text__c}" />

                    <apex:pageBlockSection columns="1"/>
                    <apex:outputField value="{!Work_Order_Activity__c.Total_Man_Hours_Text__c}" />

             
                </apex:pageBlockSection>  
            </apex:pageBlock>

        <apex:pageBlock id="editsection" mode="Edit" rendered="{!AND(NOT(workflowEngine.ViewMode), NOT(workflowEngine.PageReloadRequired))}">

            <!-- Button section for finish Edit screens -->    
            <apex:pageBlockButtons location="bottom">
                <!-- Conditionally rendered buttons based on users context -->
                <!-- Reject activity confirm button -->
<!-- Standard --> <apex:commandButton action="{!workflowEngine.RejectActivity_End}" 
                        value="{!workflowEngine.SaveButtonLabel}" 
                        rendered="{!workflowEngine.ActionMode_RejectActivity && !isSalesforce1}"/>
<!-- SF1 -->      <apex:commandButton action="{!workflowEngine.RejectActivity_End}" 
                        value="{!workflowEngine.SaveButtonLabel}" 
                        rendered="{!workflowEngine.ActionMode_RejectActivity && isSalesforce1}" 
                        oncomplete="doSfOneNavigation('{!woId}', '{!URLFOR($Site.Prefix + '/apex/VTT_ActivityDetailTimeLog')}', 'id', false)"/>
                
                <!-- StartAtEquipment,FinishedAtEquipment, FinishedForDay confirm button -->
<!-- Standard --><apex:commandButton action="{!workflowEngine.GenericActivity_End}" 
                        value="{!workflowEngine.SaveButtonLabel}" 
                        rendered="{!OR(workflowEngine.ActionMode_Generic, workflowEngine.ActionMode_StartJobAtEquipment) && !isSalesforce1}"/>
<!-- SF1 -->    <apex:commandButton action="{!workflowEngine.GenericActivity_End}" 
                        value="{!workflowEngine.SaveButtonLabel}" 
                        rendered="{!OR(workflowEngine.ActionMode_Generic, workflowEngine.ActionMode_StartJobAtEquipment) && isSalesforce1}"
                        oncomplete="doSfOneNavigation('{!woId}', '{!URLFOR($Site.Prefix + '/apex/VTT_ActivityDetailTimeLog')}', 'id', false)"/>
                
                <!-- OnHold confirm button -->
<!-- Standard --><apex:commandButton action="{!workflowEngine.ActivityOnHold_End}" 
                        value="{!workflowEngine.SaveButtonLabel}" 
                        rendered="{!workflowEngine.ActionMode_PutOnHold && !isSalesforce1}"/>
<!-- SF1 -->    <apex:commandButton action="{!workflowEngine.ActivityOnHold_End}" 
                        value="{!workflowEngine.SaveButtonLabel}" 
                        rendered="{!workflowEngine.ActionMode_PutOnHold && isSalesforce1}"
                        oncomplete="doSfOneNavigation('{!woId}', '{!URLFOR($Site.Prefix + '/apex/VTT_ActivityDetailTimeLog')}', 'id', false)"/>

 <!--                <apex:commandButton action="{!workflowEngine.JobComplete_End}" value="{!workflowEngine.SaveButtonLabel}" rendered="{!workflowEngine.ActionMode_JobComplete}"/> -->
                
                 <!-- JobComplete confirm button -->
                <apex:actionFunction name="executeWSUpdateNotification" action="{!executeWSUpdateNotification}" status="ajaxStatus"></apex:actionFunction>
<!-- Standard --><apex:commandButton action="{!JobComplete}" 
                    value="{!workflowEngine.SaveButtonLabel}" 
                    rendered="{!workflowEngine.ActionMode_JobComplete && !isSalesforce1}"
                    disabled="{!IsSelectedGreaterThanAllowed}"
                    oncomplete="executeWSUpdateNotification()" 
                    status="ajaxStatus"/>
<!-- SF1 -->    <apex:commandButton action="{!JobComplete}" 
                    value="{!workflowEngine.SaveButtonLabel}" 
                    rendered="{!workflowEngine.ActionMode_JobComplete && isSalesforce1}"
                    disabled="{!IsSelectedGreaterThanAllowed}"
                    oncomplete="doSfOneNavigation('{!woId}', '{!URLFOR($Site.Prefix + '/apex/VTT_ActivityDetailTimeLog')}', 'id', true)"/>

                  <!-- Request Reschedule confirm button -->
<!-- Standard --><apex:commandButton action="{!JobComplete}" 
                    value="{!workflowEngine.SaveButtonLabel2}" 
                    rendered="{!workflowEngine.ActionMode_JobComplete && !isSalesforce1}"
                    disabled="{!IsSelectedGreaterThanAllowed}"
                    oncomplete="executeWSUpdateNotification()" 
                    status="ajaxStatus">
                    <apex:param name="requestReschedule" value="true"/>
                 </apex:commandButton>
<!-- SF1 -->    <apex:commandButton action="{!JobComplete}" 
                    value="{!workflowEngine.SaveButtonLabel2}" 
                    rendered="{!workflowEngine.ActionMode_JobComplete && isSalesforce1}"
                    disabled="{!IsSelectedGreaterThanAllowed}"
                    oncomplete="doSfOneNavigation('{!woId}', '{!URLFOR($Site.Prefix + '/apex/VTT_ActivityDetailTimeLog')}', 'id', true)">
                    <apex:param name="requestReschedule" value="true"/>
                </apex:commandButton>
                    
                <apex:commandButton html-formnovalidate="formnovalidate" action="{!workflowEngine.VTT_CancelEdit}" immediate="true" value="Cancel" rendered="{!NOT(workflowEngine.ViewMode)}"/>                                      
            </apex:pageBlockButtons>
            <!-- End of Button section for finish Edit screens -->    

            <!-- Reject Activity Edit section -->
            <apex:pageBlocksection rendered="{!workflowEngine.ActionMode_RejectActivity}">

                <apex:pageBlockSectionItem > 
                    <apex:outputLabel value="Reject Reason:" />
                    <apex:outputPanel layout="block" styleClass="requiredInput">
                        <div class="requiredBlock"></div>    
                        <apex:inputTextarea id="rejectActivityComment" style="width:99%" required="true" value="{!workflowEngine.ActionComment}" label="Reject Reason:" rows="8"/>
                    </apex:outputPanel>
                </apex:pageBlockSectionItem> 
            </apex:pageBlocksection>
            <!-- End Reject Activity Edit section -->

            <!-- Generic Activity Edit section -->
            <apex:pageBlocksection rendered="{!OR(workflowEngine.ActionMode_Generic, workflowEngine.ActionMode_StartJobAtEquipment)}" columns="2">
                <apex:pageBlockSectionItem > 
                    <apex:outputLabel value="Comments:" />
                    <apex:outputPanel layout="block" styleClass="requiredInput">
                        <div class="requiredBlock"></div>    
                        <apex:inputTextarea style="width:99%" required="true" value="{!workflowEngine.ActionComment}" label="Comments:" rows="8"/>
                    </apex:outputPanel>
                </apex:pageBlockSectionItem>
            </apex:pageBlocksection>
            
            <apex:pageBlocksection rendered="{!AND(workflowEngine.ActionMode_Generic, Work_Order_Activity__c.Status__c == StartedAtEquipment)}" columns="1">  
                <apex:pageBlockSectionItem > 
                    <apex:outputLabel value="Gas Permit #" />
                    <apex:inputText value="{!Work_Order_Activity__c.Gas_Permit__c}"/>
                </apex:pageBlockSectionItem> 
                <apex:pageBlockSectionItem > 
                    <apex:outputLabel value="Electrical Permit #" />
                    <apex:inputText value="{!Work_Order_Activity__c.Electrical_Permit__c}"/>
                </apex:pageBlockSectionItem> 
            </apex:pageBlocksection>
            <!-- End Generic Activity Edit section -->


            <!-- Activity On Hold Edit section -->
            <apex:pageBlocksection rendered="{!workflowEngine.ActionMode_PutOnHold}" columns="2" id="onHoldsection">
            
                    <apex:pageBlockSectionItem >
                        <apex:outputLabel value="Reason:" />
                        <apex:outputPanel layout="block" styleClass="requiredInput">
                            <div class="requiredBlock"></div>
                            <apex:actionRegion >
                                <apex:selectList id="inputOnHoldReason" value="{!workflowEngine.OnHoldStatusReason}" size="1" styleClass="requiredInput" label="Reason:" required="true">
                                    <apex:selectOption itemValue="Pulled off activity" itemLabel="Pulled off activity"/>
                                    <apex:selectOption itemValue="Waiting on parts" itemLabel="Waiting on parts"/>
                                    <apex:selectOption itemValue="Waiting on information" itemLabel="Waiting on information" rendered="{!!IsThermal}"/>
                                    <apex:selectOption itemValue="Waiting on repairs" itemLabel="Waiting on repairs" rendered="{!!IsThermal}"/>
                                    <apex:actionSupport event="onchange" reRender="onHoldsection"/>
                                </apex:selectList>
                            </apex:actionRegion>
                        </apex:outputPanel>
                    </apex:pageBlockSectionItem>                             
                    <br/>
                    <apex:pageBlockSectionItem > 
                        <apex:outputLabel value="Comments:" />
                        <apex:outputPanel layout="block" styleClass="requiredInput">
                            <div class="requiredBlock"></div>    
                            <apex:inputTextarea style="width:99%" required="true" value="{!workflowEngine.ActionComment}" label="Comments:" rows="8"/>
                        </apex:outputPanel>
                    </apex:pageBlockSectionItem>
                    <br/> 
                    <apex:pageBlockSectionItem rendered="{!workflowEngine.OnHoldStatusReason == 'Waiting on parts'}" >
                            <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.Fields.Estimated_Rescheduled_Date__c.Label}:" />
                                    <apex:inputField value="{!Work_Order_Activity__c.Estimated_Rescheduled_Date__c}" />
                    </apex:pageBlockSectionItem> 
                    
            </apex:pageBlocksection>
            <!-- End of Activity On Hold Edit section -->


            <!-- Job Complete Edit section for non-Equipment work order-->
            <apex:pageBlocksection rendered="{!AND(workflowEngine.ActionMode_JobComplete, NOT(EquipmentWorkOrder), 
            workflowEngine.OtherTradesmenStillWorking.size <= 0)}" columns="2">
                    <apex:pageBlockSectionItem > 
                        <apex:outputLabel value="Comments:" />
                        <apex:outputPanel layout="block" styleClass="requiredInput">
                            <div class="requiredBlock"></div>    
                            <apex:inputTextarea style="width:99%" required="true" 
                            value="{!workflowEngine.ActionComment}" label="{!$ObjectType.Work_Order_Activity__c.Fields.Work_Details__c.Label}" rows="8"/>
                        </apex:outputPanel>
                    </apex:pageBlockSectionItem> 
            </apex:pageBlocksection>
            <!-- End Job Complete Edit section for non-Equipment work order-->


            <!-- Job Complete Edit section for Equipment Work Order -->
            <apex:pageBlocksection title="Parts and Damages" rendered="{!AND(workflowEngine.ActionMode_JobComplete, EquipmentWorkOrder,
                workflowEngine.OtherTradesmenStillWorking.size <= 0)}" columns="1">

                <apex:panelGrid id="damageEdit" columns="4" width="70%" columnClasses="label, dataCol, label, dataCol">
                    <apex:outputlabel value="Parts" rendered="{!showPartsDamageCause}"/>
                     <apex:actionRegion rendered="{!showPartsDamageCause}">
                     <apex:outputpanel styleClass="requiredInput"> 
                     <apex:outputpanel layout="block" styleClass="requiredBlock"/>                
                        <apex:selectList value="{!partItem}" size="1" style="width:60%">
                            <apex:actionSupport event="onchange" reRender="damageSection" action="{!damagesSelection}"/>
                            <apex:selectOptions value="{!partsOptions}"/>
                        </apex:selectList>
                     </apex:outputpanel>
                    </apex:actionRegion>
                    <apex:outputText rendered="{!showPartsDamageCause}"/>
                    <apex:outputText rendered="{!showPartsDamageCause}"/>

                    <apex:outputlabel value="Damage" rendered="{!showPartsDamageCause}"/>
                    <apex:outputpanel id="damageSection" styleClass="requiredInput" rendered="{!showPartsDamageCause}">
                        <apex:outputpanel layout="block" styleClass="requiredBlock"/>  
                        <apex:selectList value="{!damageItem}" size="1" style="width:60%">
                            <apex:selectOptions value="{!damagesOptions}"/>
                        </apex:selectList>
                    </apex:outputpanel>
                    <apex:outputText rendered="{!showPartsDamageCause}"/>
                    <apex:outputText rendered="{!showPartsDamageCause}"/>                    

                    <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.Fields.Damage_Text__c.Label}" rendered="{!showPartsDamageCause}"/>
                    <apex:outputPanel layout="block" styleClass="requiredInput" rendered="{!showPartsDamageCause}">
                        <div class="requiredBlock"></div>    
                           <apex:inputTextarea id="damageText" 
                           label="{!$ObjectType.Work_Order_Activity__c.Fields.Damage_Text__c.Label}" 
                           required="true" style="width:99%" value="{!Work_Order_Activity__c.Damage_Text__c}" rows="3"/>
                    </apex:outputPanel>                    
                    <apex:outputText rendered="{!showPartsDamageCause}"/>
                    <apex:outputText rendered="{!showPartsDamageCause}"/>                   

                    <apex:outputlabel value="Cause" rendered="{!showPartsDamageCause}"/>
                     <apex:outputpanel styleClass="requiredInput" rendered="{!showPartsDamageCause}"> 
                        <apex:outputpanel layout="block" styleClass="requiredBlock"/>                      
                        <apex:selectList value="{!causeItem}" size="1" style="width:60%">
                            <apex:selectOptions value="{!causesOptions}"/>
                        </apex:selectList>
                    </apex:outputpanel>
                    <apex:outputText rendered="{!showPartsDamageCause}"/>
                    <apex:outputText rendered="{!showPartsDamageCause}"/>

                    <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.Fields.Cause_Text__c.Label}" rendered="{!showPartsDamageCause}"/>
                    <apex:outputPanel layout="block" styleClass="requiredInput" rendered="{!showPartsDamageCause}">
                        <div class="requiredBlock"></div>    
                        <apex:inputTextarea id="causeText" 
                        label="{!$ObjectType.Work_Order_Activity__c.Fields.Cause_Text__c.Label}" 
                        required="true" style="width:99%" value="{!Work_Order_Activity__c.Cause_Text__c}" rows="3"/>
                    </apex:outputPanel>
                    <apex:outputText rendered="{!showPartsDamageCause}"/>
                    <apex:outputText rendered="{!showPartsDamageCause}"/>

                    <apex:outputLabel value="{!$ObjectType.Work_Order_Activity__c.Fields.Work_Details__c.Label}" />
                    <apex:outputPanel layout="block" styleClass="requiredInput">
                        <div class="requiredBlock"></div>    
                        <apex:inputTextarea style="width:99%" required="true" value="{!workflowEngine.ActionComment}" label="{!$ObjectType.Work_Order_Activity__c.Fields.Work_Details__c.Label}" rows="3"/>
                    </apex:outputPanel>
                    <apex:outputText />
                    <apex:outputText />

                    <apex:outputText />
                </apex:panelGrid>

            </apex:pageBlocksection>
            <!-- Job Complete Edit section for non-Equipment work order-->

            <!-- Job Complete Edit section if other tradesmen still working -->
            <apex:pageBlockSection title="Complete Activity:" rendered="{!AND(workflowEngine.ActionMode_JobComplete, workflowEngine.OtherTradesmenStillWorking.size > 0)}">
                <apex:pageMessage title="Tradesmen Still Working" summary="The following people are still working the activity. You will be logged as “Finished” for this activity." severity="warning" strength="1"/>
                <br/>
                <apex:pageBlockTable styleClass="table table-condensed table-hover" value="{!workflowEngine.OtherTradesmenStillWorking}"
                    var="tradesmanRec" title="Working Tradesmen">
                    <apex:column value="{!tradesmanRec.Name}"/>
                    <apex:column value="{!tradesmanRec.Account.Name}"/>
                    <apex:column value="{!tradesmanRec.Phone}"/>
                    <apex:column value="{!tradesmanRec.Tradesman_Status__c}"/>
                    <apex:column value="{!tradesmanRec.Tradesman_Status_Date__c}"/>
                </apex:pageBlockTable>
            </apex:pageBlockSection>
            <!-- Job Complete Edit section if other tradesmen still working -->

            <!-- Execution Close Out Checklist  -->
            <!-- TODO add Rendered only for Thermal -->
            <c:VTT_Close_Out_Checklist CheckListState="{!workflowEngine.checklistState}"
                CloseOutCheckList="{!workflowEngine.CloseOutCheckList}"
                SelectedPermitOption="{!workflowEngine.selectedPermitOption}"
                isTradesmenPermitHolder="{!workflowEngine.isTradesmenPermitHolder}"
                WorkOrderNumber="{!workflowEngine.workOrderNumber}"
                CompanyName="{!workflowEngine.Tradesman.Account.Name}"
                isThermal="{!IsThermal}"
                isEditable="true"
                actionName="{!workflowEngine.ActionName}"
                ActionMode_JobComplete="{!workflowEngine.ActionMode_JobComplete}"
                ActionMode_PutOnHold="{!workflowEngine.ActionMode_PutOnHold}"/>
            
            <!-- Job Complete Edit section to Complete Multiple activities-->    
            <apex:actionregion >
                <apex:pageBlocksection id="RunningTallyTime" title="Time Distribution & Recalculation Section:" rendered="{!AND(workflowEngine.ActionMode_JobComplete, workflowEngine.AvailableActivitiesToComplete.size>0, workflowEngine.OtherTradesmenStillWorking.size <= 0)}" columns="1">
                
                    
                    <apex:pageBlockSectionItem >
                        <apex:outputPanel >
                            
                            <apex:outputText value="Running tally time available for selected Work Order Activities is: " styleClass="runningTallyText"/>
                            <apex:outputText value="{!IF(FLOOR(workflowEngine.runningTally) = 0, 0, FLOOR(workflowEngine.runningTally-1))}" styleClass="runningTallyTime"/>
                            <apex:outputText value="min(s)" styleClass="runningTallyText"/>

                                <apex:commandLink rerender="" 
                                    styleClass="btn custom_btn" action="{!recountAvailableTime}"
                                    value="Recalculate"
                                    status="status"
                                    reRender="RunningTallyTime, CompleteMultiple, errors"
                                />

                            </apex:outputPanel>
                    </apex:pageBlockSectionItem>
                </apex:pageBlocksection>
                <apex:pageBlocksection rendered="{!AND(workflowEngine.ActionMode_JobComplete, workflowEngine.AvailableActivitiesToComplete.size>0, workflowEngine.OtherTradesmenStillWorking.size <= 0)}" columns="1">
                    <apex:pageBlockSectionItem >
                        <apex:outputPanel >
                            <apex:outputText value="Split remaining time between Work Order Activities with '0' time assigned: " style="font-weight:bold;font-size: 1.1em;"/>
                                
                                <apex:commandLink rerender="" 
                                    styleClass="btn custom_btn" action="{!distributeAvailableTime}"
                                    value="Distribute Available Time"
                                    status="status"
                                    reRender="RunningTallyTime, CompleteMultiple, errors"
                                />

                                <apex:actionStatus id="status">
                                    <apex:facet name="start">
                                        <apex:image value="{!$Resource.Waiting}"/>
                                    </apex:facet>
                                </apex:actionStatus>
                        </apex:outputPanel>
                    </apex:pageBlockSectionItem>
                </apex:pageBlocksection>
                <apex:pageBlocksection rendered="{!AND(workflowEngine.ActionMode_JobComplete, workflowEngine.AvailableActivitiesToComplete.size>0, workflowEngine.OtherTradesmenStillWorking.size <= 0)}" columns="1">
                    <apex:pageBlockSectionItem >
                        <apex:outputPanel >
                            <apex:outputText styleClass="hint" value="(Hint: Distribute Available Time button redistributes the remainder of the running tally between selected Work Order Activities, that have zero time assigned.)"/>
                        </apex:outputPanel>
                    </apex:pageBlockSectionItem>
                </apex:pageBlockSection>
                <apex:pageBlocksection id="CompleteMultiple" title="Complete max. {!MaxAutoCompleteAllowed} Activities. Selected: {!IF(numberOfChecked=null, 0, numberOfChecked)}/{!MaxAutoCompleteAllowed}" rendered="{!AND(workflowEngine.ActionMode_JobComplete, workflowEngine.AvailableActivitiesToComplete.size>0, workflowEngine.OtherTradesmenStillWorking.size <= 0)}" columns="1">
                   <apex:pageMessage summary="You can only select {!MaxAutoCompleteAllowed} to autcomplete at one time. Please unselect the additional activities on the page." 
                    severity="error" strength="3" rendered="{!IsSelectedGreaterThanAllowed}"/>
                   <apex:actionstatus id="ajaxStatus">
                        <apex:facet name="start">
                            <div class="waitingSearchDiv" id="el_loading" style="background-color: rgb(54, 25, 25); background-color: rgba(25, 25, 25, .5); height: 100%;width:100%;">
                                <div class="waitingHolder" style="top: 200px; width: 200px; height: 40px; border:1px solid black;  background-color: white;">
                                    <p>
                                        <img class="waitingImage" src="/img/loading.gif" title="Please Wait..." />
                                        <span class="waitingDescription">Please Wait...</span>
                                    </p>
                                </div>
                            </div>
                        </apex:facet> 
                    </apex:actionstatus>

                    <apex:pageBlockSectionItem >
                        <apex:outputPanel >
                            <apex:outputText value="Current Work Order Activity <b>{!Work_Order_Activity__c.Name}</b> will be assigned with <b>{!FLOOR(workflowEngine.runningTally)}</b> min(s)." escape="false"/>
                        </apex:outputPanel>
                    </apex:pageBlockSectionItem>
                    
                  <apex:pageBlockTable styleClass="table table-condensed table-hover" 
                  value="{!workflowEngine.AvailableActivitiesToComplete}" var="rec" title="Activities" >

                    <apex:column >
                        <apex:facet name="header">
                            <apex:inputCheckbox value="{!checkedAll}" >
                                <apex:actionSupport event="onchange" action="{!selectAllActivitiesToAutoComplete}" reRender="CompleteMultiple, errors, RunningTallyTime" status="status"/>
                            </apex:inputCheckbox>
                        </apex:facet>                
                        <apex:inputCheckbox value="{!rec.MarkToComplete}"  id="inputId" styleClass="singleCheckbox" disabled="{!rec.IsLimitMet}">
                            <apex:actionsupport event="onchange" action="{!selectActivityToAutoComplete}" rerender="CompleteMultiple,RunningTallyTime,editsection"/> 
                        </apex:inputCheckbox>
                    </apex:column>
                    <apex:column headerValue="Activity" value="{!rec.ActivityRecord.Name}"/>
                    <apex:column headerValue="Status" value="{!rec.ActivityRecord.Status__c}"/>
                    <apex:column value="{!rec.ActivityRecord.System_Condition__c}"/>
                    <apex:column id="RunningTally">
                        <apex:facet name="header">
                            <apex:outputText value="Time to spend on selected WOA [min]" style="padding:3px"/>
                        </apex:facet>
                        <apex:input type="number" value="{!rec.UserDurationInput}" rendered="{!rec.MarkToComplete}" onkeypress="return (event.charCode == 8 || event.charCode == 0 || event.charCode == 13) ? null : event.charCode >= 48 && event.charCode <= 57">
                            <!-- <apex:actionSupport event="onchange" action="{!recountAvailableTime}" reRender="RunningTallyTime"/> -->
                        </apex:input>
                    </apex:column>
                    <apex:column value="{!rec.ActivityRecord.Scheduled_Start_Date__c}"/>
                    <apex:column value="{!rec.ActivityRecord.Scheduled_Finish_Date__c}"/>
                    <apex:column headerValue="Description of Equipment" value="{!rec.ActivityRecord.Equipment__r.Description_of_Equipment__c}"/>
                    <apex:column value="{!rec.ActivityRecord.Location__c}"/>
                    <apex:inputHidden value="{!rec.ActivityRecord.is_Mass_Complete__c}"/>
                  </apex:pageBlockTable>
                  <apex:pageMessage summary="You can only select {!MaxAutoCompleteAllowed} to autcomplete at one time. Please unselect the additional activities on the page." 
                    severity="error" strength="3" rendered="{!IsSelectedGreaterThanAllowed}"/>
                </apex:pageBlocksection>
            </apex:actionregion>
            <!-- End of Job Complete Edit section -->
        </apex:pageBlock>
    </apex:form>

    <apex:relatedList list="Work_Order_Activity_Assignments__r" rendered="{!workflowEngine.ViewMode}"/>
    <apex:relatedList list="Work_Order_Activity_Logs__r" rendered="{!workflowEngine.ViewMode}"/>
    <apex:relatedList list="Work_Execution_and_Close_Out_Checklists__r" rendered="{!workflowEngine.ViewMode}"/>
    <apex:relatedList list="Work_Order_Activity_Confirmations__r" rendered="{!workflowEngine.ViewMode}"/>
    <!-- <apex:relatedList list="Work_Order_Activity_Reschedule_Requests__r" rendered="{!WorkflowEngine.ViewMode}"/> -->
      
    <apex:relatedList title="Work Order Attachments" list="CombinedAttachments" subject="{!Work_Order_Activity__c.Maintenance_Work_Order__c}" rendered="{!workflowEngine.ViewMode}"/>       
    <apex:relatedList title="Activity Attachments" list="CombinedAttachments" rendered="{!workflowEngine.ViewMode}"/>
</apex:page>